\\ Copyright 2014, 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


read("../tools/memoize.gp");
read("pol-pfrac.gp");

default(recover,0);
check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

b = 1+I;
L(k) = if(k<0,error("L k<0"), k<=3,2^k, L(k-1) + 2*L(k-3));
L=memoize(L);
R(k)=1 + sum(j=0,k-1, L(j));
R = memoize(R);
RQ(k)=1 + sum(j=0,k-1, LQ(j));
RQ = memoize(RQ);
B(k) = R(k+1);
A(k) = 2^(k-1) - B(k)/4;
JA(k) = A(k+1) - 2*A(k);
JEQ(k) = (3/5 + 1/5*I)*b^k - (1/10 - 3/10*I)*(-1)^k;
LQ(k) = if(k<0,error("LQ() is for k>=0")); \
        if(k==0,return(1)); \
        if(k<=3,return(2^(k-1))); \
        LQ(k-1) + 2*LQ(k-3);
LQ = memoize(LQ);
gLQ(x) = (1     + x^2) / (1 - x - 2*x^3);
gRQ(x) = (1 + x + x^2) / (1-x-2*x^3);
gBQ(x) = (2 + x + 2*x^2) / (1-x-2*x^3);
\\ LQ+RQ == BQ

gJA(x) = x^3 / ((1 - x - 2*x^3)*(1-x));
\\ gJA(x) == 1/2*( - 1/(1-x) + 1/(1-x-2*x^3) )

vector_modulo(v,i) = v[(i% #v)+1];

\\-----------------------------------------------------------------------------

BlobStart(k) = 1/3*(conj(b)*b^k + boff(k));
BlobEnd(k) = 1/3*(2*b^k - I* boff(k-1));
boff(m) = vector_modulo(boff_vector,m);
boff_vector = [2 + I, 1 + 3*I, -2 + 4*I, -3 + 2*I, -2 - I, -1 - 3*I, 2 - 4*I, 3 - 2*I];
BlobDelta_ref(k) = BlobEnd(k) - BlobStart(k);

BlobDelta(k) = 1/3*(2*b^k - I* boff(k-1)) - 1/3*(conj(b)*b^k + boff(k));
check_exact(vector(64,k,my(k=k+3); BlobDelta(k)), \
            vector(64,k,my(k=k+3); BlobDelta_ref(k)));

BlobDelta(k) = 1/3*(2*b^k - I* boff(k-1) - conj(b)*b^k - boff(k));
check_exact(vector(64,k,my(k=k+3); BlobDelta(k)), \
            vector(64,k,my(k=k+3); BlobDelta_ref(k)));

BlobDelta(k) = {
  1/3*((2- conj(b))*b^k
       + vector_modulo(-I*[2 + I, 1 + 3*I, -2 + 4*I, -3 + 2*I, -2 - I, -1 - 3*I, 2 - 4*I, 3 - 2*I],k-1)
       - vector_modulo([2 + I, 1 + 3*I, -2 + 4*I, -3 + 2*I, -2 - I, -1 - 3*I, 2 - 4*I, 3 - 2*I],k));
}
check_exact(vector(64,k,my(k=k+3); BlobDelta(k)), \
            vector(64,k,my(k=k+3); BlobDelta_ref(k)));

BlobDelta(k) = 1/3*(b*b^k \
  + vector_modulo([-4 - 4*I, -5*I, 5 - 5*I, 7, 4 + 4*I, 5*I, -5 + 5*I, -7],k));
check_exact(vector(64,k,my(k=k+3); BlobDelta(k)), \
            vector(64,k,my(k=k+3); BlobDelta_ref(k)));

\\ [(-4 - 4*I)/b, -5*I/b^2, (5 - 5*I)/b^3, 7/b^4, (4 + 4*I)/b^1, (5*I)/b^2, (-5 + 5*I)/b^3, -7/b^4]
BlobDelta(k) = 1/3*(b*b^k \
   + b^((k%4)+1)*vector_modulo([-4, -5/2, -5/2, -7/4, 4, 5/2, 5/2, 7/4],k));
check_exact(vector(64,k,my(k=k+3); BlobDelta(k)), \
            vector(64,k,my(k=k+3); BlobDelta_ref(k)));

\\-----------------------------------------------------------------------------
\\ len
            
dir8(k) = vector_modulo([1,b,I,-conj(b), -1,-b,-I,conj(b)], k);
\\ BlobDelta(k) = dir8(k+1) * (2^(ceil((k-4)/2)) \
\\    + vector_modulo([0,1,1,-1, -1,-1,-1,-1],k));
\\ check_exact(vector(16,k,my(k=k+3); BlobDelta(k)), \
\\             vector(16,k,my(k=k+3); BlobDelta_ref(k)));

BlobDelta(k) = 1/3*(b*2^floor(k/2)*dir8(k) \
   + vector_modulo([-4 - 4*I, -5*I, 5 - 5*I, 7, 4 + 4*I, 5*I, -5 + 5*I, -7],k));
check_exact(vector(64,k,my(k=k+3); BlobDelta(k)), \
            vector(64,k,my(k=k+3); BlobDelta_ref(k)));

BlobDelta(k) = 1/3*(2^ceil(k/2)*dir8(k+1) \
   + vector_modulo([-4 - 4*I, -5*I, 5 - 5*I, 7, 4 + 4*I, 5*I, -5 + 5*I, -7],k));
check_exact(vector(64,k,my(k=k+3); BlobDelta(k)), \
            vector(64,k,my(k=k+3); BlobDelta_ref(k)));

BlobDelta(k) = dir8(k+1)*1/3*(2^ceil(k/2) \
   + 1/dir8(k+1)*vector_modulo([-4 - 4*I, -5*I, 5 - 5*I, 7, 4 + 4*I, 5*I, -5 + 5*I, -7],k));
check_exact(vector(64,k,my(k=k+3); BlobDelta(k)), \
            vector(64,k,my(k=k+3); BlobDelta_ref(k)));

BlobDelta(k) = dir8(k+1)*1/3*(2^ceil(k/2) - vector_modulo([4, 5, 5, 7],k));
check_exact(vector(64,k,my(k=k+3); BlobDelta(k)), \
            vector(64,k,my(k=k+3); BlobDelta_ref(k)));

BlobDeltaLen(k) = 1/3*(2^ceil(k/2) - vector_modulo([4, 5, 5, 7],k));
vector(64,k,my(k=k+3); BlobDeltaLen(k))

\\-----------------------------------------------------------------------------
\\ norm
            
BlobDeltaNorm(k) = norm(BlobDelta(k));
check_exact(vector(64,k,my(k=k+3); BlobDeltaNorm(k)), \
            vector(64,k,my(k=k+3); norm(BlobDelta_ref(k))));

BlobDeltaNorm(k) = vector_modulo([2,1],k) * (1/3*(2^ceil(k/2) - vector_modulo([4, 5, 5, 7],k)))^2;
check_exact(vector(64,k,my(k=k+3); BlobDeltaNorm(k)), \
            vector(64,k,my(k=k+3); norm(BlobDelta_ref(k))));

BlobDeltaNorm(k) = vector_modulo([2,1],k) \
   * 1/9*(2^ceil(k/2) - vector_modulo([4, 5, 5, 7],k))^2;
check_exact(vector(64,k,my(k=k+3); BlobDeltaNorm(k)), \
            vector(64,k,my(k=k+3); norm(BlobDelta_ref(k))));

BlobDeltaNorm(k) = vector_modulo([2,1],k) \
   * 1/9*(2^ceil(k/2) - vector_modulo([4, 5, 5, 7],k)) \
        *(2^ceil(k/2) - vector_modulo([4, 5, 5, 7],k));
check_exact(vector(64,k,my(k=k+3); BlobDeltaNorm(k)), \
            vector(64,k,my(k=k+3); norm(BlobDelta_ref(k))));

BlobDeltaNorm(k) = vector_modulo([2,1],k) \
   * 1/9*(2^(2*ceil(k/2)) \
          - 2*vector_modulo([4, 5, 5, 7],k)*2^ceil(k/2) \
          + vector_modulo([16, 25, 25, 49],k));
check_exact(vector(64,k,my(k=k+3); BlobDeltaNorm(k)), \
            vector(64,k,my(k=k+3); norm(BlobDelta_ref(k))));

BlobDeltaNorm(k) =  \
  1/9*(vector_modulo([2,1],k)*vector_modulo([1, 2],k)*2^k \
          - vector_modulo([2,1],k)*vector_modulo([8, 10, 10, 14],k)*2^ceil(k/2) \
          + vector_modulo([2,1],k)*vector_modulo([16, 25, 25, 49],k));
check_exact(vector(64,k,my(k=k+3); BlobDeltaNorm(k)), \
            vector(64,k,my(k=k+3); norm(BlobDelta_ref(k))));

BlobDeltaNorm(k) =  \
  1/9*(2*2^k \
       - vector_modulo([16, 10, 20, 14],k)*2^ceil(k/2) \
       + vector_modulo([32, 25, 50, 49],k));
check_exact(vector(64,k,my(k=k+3); BlobDeltaNorm(k)), \
            vector(64,k,my(k=k+3); norm(BlobDelta_ref(k))));

BlobDeltaNorm(k) =  \
  1/9*(2*2^k \
       - vector_modulo([16, 20, 20, 28],k)*2^floor(k/2) \
       + vector_modulo([32, 25, 50, 49],k));
check_exact(vector(64,k,my(k=k+3); BlobDeltaNorm(k)), \
            vector(64,k,my(k=k+3); norm(BlobDelta_ref(k))));



