\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------
\\ k=1000; BlobN(k+1)/2^k*1.0  \\ 4/5

\\ +1 arm  A115451
\\  2/15*2^k + vector_modulo([-2/15, -4/15, 7/15, -1/15],k)
\\  1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 10
\\
\\ -1 arm  not in OEIS as 22/15 or 7/15
\\ 1011 1011 1011 1011 1011 1011 1011 1011 1100
vector(15,k, 22/15 * 2^k + vector_modulo([-7/15, 1/15, 2/15, 4/15],k))
vector(15,k, 7/15 * 2^k + vector_modulo([-7/15, 1/15, 2/15, 4/15],k))
\\ as 1-7/15 is 8/15 is A115451 again
vector(15,k, 2^k - (7/15 * 2^k + vector_modulo([-7/15, 1/15, 2/15, 4/15],k)))

\\      +1 ^               |
\\         |               |
\\         |               |
\\         |               |
\\    2/15 |L   L          |     bridge before blob k
\\         |   2/5         v
\\         *----+--------> *
\\         |    R
\\         |
\\         |
\\         |
\\      -1 v      R            (1+7/15)*2^k
\\         * <------------ *

\\ k=32 n=1717986916
\\ binary(1717986916+1)
\\       t                                     t
\\ inf0s 011 0 011 0 011 0 011 0 011 0 011 0 0101
\\       ^^^   ^^^   ^^^   ^^^   ^^^   ^^^   ^^


\\ binary(1717986916+2)
\\       t                                   t
\\ inf0s 1 100 1 100 1 100 1 100 1 100 1 100 110
\\   ^^^   ^^^   ^^^   ^^^   ^^^   ^^^   ^^^
\\    1s 1 011 1 011 1 011 1 011 1 011 1 011 110
\\    0s 0 100 0 100 0 100 0 100 0 100 0 100 010  comp
\\ from_binary(100 0 100 0 100 0 100 0 100 0 100 0 100 010) == 572662306
\\
\\             100 0 100 0 100 0 100 0 100 0 100 0 100 0 10
{
  my(lR=List([]),lL=List([]));
  for(k=4,32,
     my(n=BlobN(k+1)-3);
     print("k="k" n="n"  at "dragon_point_by_sum(n));
     my(nL,nR);
     if(turn(n+1)==1, nR=n+1; nL=n+2,   \\ n+1 is left turn so right side
                      nL=n+1; nR=n+2);
     my(aoR=dragon_n_to_arm_and_other(nR));
     my(aoL=dragon_n_to_arm_and_other(nL));
     print("  R ",aoR,"  at ",dragon_point_by_sum(nR));
     print("  L ",aoL,"  at ",dragon_point_by_sum(nL));
     if(aoR[1]>0,error("oops R"));
     if(aoL[1]<0,error("oops L"));
     listput(lL,aoL[2]);
     listput(lR,aoR[2]);
  );
  vR=Vec(lR);
  vL=Vec(lL);
  print(vR);
  print(vL);
  vR=concat(vector(4),vR);
  vL=concat(vector(4),vL);
  recurrence_guess(vR);
  recurrence_guess(vL);
}

\\ ^
\\ |
\\ |
\\ |
\\ |
\\ |
\\ O-----------|---->
\\ |                 ^
\\ |                 |
\\ |                 |
\\ |                 |
\\ |                 |
\\ v <--------------
\\

\\ after blob k
BridgeOtherR(k) =
{
  (2+14/15) * 2^k + 1/15*vector_modulo([1, 2, 4, -7],k);
}
BridgeOtherL(k) =
{
   4/15 * 2^k + 1/15*vector_modulo([-4, 7, -1, -2],k);
}
check_exact(44/15, 2+14/15);

print("R ",vector(10,k,k--;if(k<4,0, BridgeOtherR(k))));
print("L ",vector(10,k,k--;if(k<4,0, BridgeOtherL(k))));

check_exact(vector(#vR,k,k--;if(k<4,0, BridgeOtherR(k))), vR, "R");
check_exact(vector(#vL,k,k--;if(k<4,0, BridgeOtherL(k))), vL, "L");
