\\ Copyright 2014, 2015, 2016, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


cbrt(x) = simplify(x)^(1/3.0);

poly = 164*x^3 + 84*x^2 + 25*x + 4;  \\ R centroid imag
poly = x^3 + x^2 - 2*x - 1;  \\ terdragon k=2 adjacency matrix
poly = x^3 - x^2 - 2;  \\ dragon curve
poly = x^3 - 8*x^2 + 15*x - 4; \\ terdragon k=2 Laplacian matrix eigenvalue
poly = x^3 - x^2 - 1;
poly = (x-1)^2*x;
L=O(z^10);
poly = (1+z+L)*'x^3 - (2+L)*'x^2 + (1-z+2*z^2+L)*'x - z^2+L;  \\ equimatchable g2
print(poly)

poly2 = poly / polcoeff(poly,3,'x);
print("divide out a3,  poly2 = ",poly2)

a0 = polcoeff(poly2,0,'x);
a1 = polcoeff(poly2,1,'x);
a2 = polcoeff(poly2,2,'x);

lambda = a2/3;
print("lambda=",lambda)

poly3 = subst(poly2,x, x - lambda);
print("substitute x-lambda  poly3 = ",poly3)

p = ( 3*a1 - a2^2 )/3;
q = ( 9*a1*a2 - 27*a0 - 2*a2^3 )/27;
print("p=",p)
print("q=",q)
p == polcoeff(poly3,1,'x) || error("oops");
q == - polcoeff(poly3,0,'x) || error("oops");

poly4 = subst(poly3,x, w - p/(3*w));
print("substitute x=w-p/3w   ",poly4)

poly5 = poly4 * w^3;
print("mul w^3 to  ",poly5)

a = polcoeff(poly5,6,'w);
b = polcoeff(poly5,3,'w);
c = polcoeff(poly5,0,'w);
disc = b^2 - 4*a*c;
print("a = "a)
print("b = "b)
print("c = "c)

R = 1/2*q;
Q = 1/2*p;

d = -1/2*b;
s = (b^2 - 4*a*c)/4;
print("d = "d)
print("discriminant s = "s)

w2_cubed = d - sqrt(s);
w1_cubed = d + sqrt(s);
print("w = cbrt of  "d" +/- sqrt("s")")
w1 = cbrt(w1_cubed);
print("w1 subst, should be zero ",Strprintf("%.4g",abs(subst(poly5,'w,w1))))
w2 = cbrt(w2_cubed);
print("w2 subst, should be zero ",Strprintf("%.4g",abs(subst(poly5,'w,w2))))

print()

x3 = w1 - (cbrt(p^3/(27*w1_cubed)));
print("x3 = " x3)
w1_cubed_other = p^3/27/w1_cubed;
x3 = cbrt(w1_cubed) - cbrt(w1_cubed_other);
print("x3 = " x3)

print()

sgn = -1;
x3 = w1 - p/(3*w1);
print("x3 from w1 = " x3)
x3 = w1 - p/(cbrt(27*w1_cubed));
print("x3 = " x3)
print("x3 subst in poly3, should be zero ",Strprintf("%.4g",abs(subst(poly3,'x,x3))))
print()

\\ w1_cubed_other = p^3/27/w1_cubed;
\\ print("other = " w1_cubed_other)
\\ w1_cubed_other = -d - sqrt(s);
\\ print("other = " w1_cubed_other)
\\ print()

\\ print("x2 for poly3 = " x2)
x2 = x3 - lambda;
print("x2 = x3 - lambda = " x2)
print("x2 subst poly2 ",Strprintf("%.4g",abs(subst(poly2,'x,x2))))
print("x2 subst original ",Strprintf("%.4g",abs(subst(poly,'x,x2))))

x2 =       cbrt(d - sqrt(s))    + cbrt(d + sqrt(s)) + -lambda;
print("x2 = cbrt("d"-sqrt("s")) + cbrt("d"+sqrt("s")) + ", -lambda)
print("   = " x2);
print();


print("-------");
w = -1/2 + 1/2*quadgen(-12);
p1 = a2^2*a1^2 + 18*a2*a1*a0 - 4*a1^3 - 27*a0^2 - 4*a2^3*a0;
p2 = 9*a2*a1 - 27*a0 - 2*a2^3;
print("p1 = ",p1);
print("p2 = ",p2);

s_squared = -3*p1;
print("s = sqrt(",s,")");
c1_cubed = (p2 + 3*sqrt(s_squared))/2;
c2_cubed = (p2 - 3*sqrt(s_squared))/2;
c1 = cbrt(c1_cubed);
c2 = cbrt(c2_cubed);
print("c1 = cbrt("p2" + 3*sqrt("s_squared")) = ",c1);
print("c2 = cbrt("p2" - 3*sqrt("s_squared")) = ",c2);
print("u1 = (",-a2," + w*c1 + w^2*c2)/3");
print("u3 = (",-a2," + w*c2 + w^2*c1)/3");
print("u2 = (",-a2," + c1 + c1)/3");

\\ c1*c2 = a2^2 - 3*a1
\\ c1*c2 = cbrt( (p2+3s)/2 * (p2-3s)/2 )
c1c2_cubed = (p2+3*s)/2 * (p2-3*s)/2;
print("c1*c2 = ",c1*c2);
print("c1*c2 cubed = ",c1c2_cubed);
print("a2^2-3*a1 = ",a2^2-3*a1);
\\ for(i=0,2,for(j=0,2,if(w^(i+i+j)*
c1_w_pow = 0;
c2_w_pow = 0;

\\ f=2*41;
\\ d *= f^3;
\\ s *= f^6;
\\ lambda *= f;
\\ print("x2 = 1/"f" * (cbrt("d"-sqrt("s")) + cbrt("d"-sqrt("s")) + ", -lambda," )")
\\ x2 = 1/f*(cbrt(d-sqrt(s)) - conj(cbrt(-d-sqrt(s))) - lambda);
\\ print("x2 = " x2)

polroots(poly)

