\\ Copyright 2016, 2017, 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------
\\ FFFFD run fpoints

FFFD(n) =
{
  my(bitlen=4*(n+1), v=vector(bitlen,i, i!=bitlen-1));
  fromdigits(v,2)/2^#v;
}
check_exact(FFFD(0), 13/16);
check_exact(FFFD(1), 253/256);

for(n=0,10, print(dragon_fpoint(FFFD(n))));

{
  for(n=0,10,
     check_exact(dragon_fpoint(FFFD(n)),
                1 + (-1)^(n+1) * 1/2^(2*(n+1))));
}

check_exact(dragon_fpoint(FFFD(0)),      from_binary_str( ".11"));
check_exact(dragon_fpoint(FFFD(1)),      from_binary_str("1.0001"));
check_exact(dragon_fpoint(FFFD(2)),      from_binary_str( ".111111"));
check_exact(dragon_fpoint(FFFD(3)),      from_binary_str("1.00000001"));
check_exact(dragon_fpoint(FFFD(4)),      from_binary_str( ".1111111111"));
check_exact(dragon_fpoint(FFFD(5)),      from_binary_str("1.000000000001"));

check_exact(dragon_fpoint(FFFD(0)/16),   from_binary_str("-.0011"));
check_exact(dragon_fpoint(FFFD(0)/16^2), from_binary_str( ".0000 11"));
check_exact(dragon_fpoint(FFFD(0)/16^3), from_binary_str("-.0000 0011"));

check_exact(dragon_fpoint(FFFD(1)/16^2), from_binary_str( ".00010001")); \\
check_exact(dragon_fpoint(FFFD(1)/16^3), from_binary_str("-.0000010001"));
check_exact(dragon_fpoint(FFFD(1)/16^4), from_binary_str( ".000000010001"));

check_exact(dragon_fpoint(FFFD(2)/16^3), from_binary_str("-.0000 0011 1111"));
check_exact(dragon_fpoint(FFFD(2)/16^4), from_binary_str( ".0000 0000 111111"));
check_exact(dragon_fpoint(FFFD(2)/16^5), from_binary_str("-.0000 0000 00111111"));

check_exact(dragon_fpoint( \
  from_binary_str(" .1101")), \
  from_binary_str(" .11"));
check_exact(dragon_fpoint( \
  from_binary_str(" .1101 0000 1111 1101")), \
  from_binary_str(" .1101 0001"));
check_exact(dragon_fpoint( \
  from_binary_str(" .0000 0000 1111 1101")), \
  from_binary_str(" .0001 0001"));

check_exact(dragon_fpoint( \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 0000 1101")), \
  from_binary_str("-.0000 0000 0000 0011"));    /* -3 */
check_exact(dragon_fpoint( \
  from_binary_str(" .1101 0000 1111 1101 0000 0000 0000 1101")), \
  from_binary_str(" .1101 0000 1111 1101"));
\\                      1    2    3    4    5    6    7    8

check_exact(dragon_fpoint( \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 1101")), \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 0000 1100"));
check_exact(dragon_fpoint( \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000000011111101")), \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 0000 0001 0001"));
check_exact(dragon_fpoint( \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 1101000011111101")), \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 0000 1101 0001"));
\\                      1    2    3    4    5    6    7    8    9   19   11   12   13   14   15

\\ for 8 put 1101 at 15 want gap 9 to 14 = 6 of so 100..001 of that width is 12 long FFFD       1,1,12
\\ leaves +1 above
\\ 7 len 1  -> 14 len 1, 16 len 12  ending 16+12 = 28
check_exact(dragon_fpoint( \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 11010000111111111111111111111111111111111111111111111101")), \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 0000 1101 0000 0000 0000 0000 0000 0001"));

\\ -3 at hex 15 is D at -30
check_exact(dragon_fpoint( \
  from_binary_str(" .0000 0000 0000 0000 0000 1101")), \
  from_binary_str("-.0000 0000 0011"));
check_exact(dragon_fpoint( \
  from_binary_str(" .0000 0000 1101 0000 1111 1101")), \
  from_binary_str(" .0000 1101 0001"));
check_exact(dragon_fpoint( \
  from_binary_str(" .0000 0000 0000 0000 0000 0000 1101")), \
  from_binary_str(" .0000 0000 0000 11"));

\\ n=1101                                                             1
\\   0000                                                             1
\\
\\   11111101                                                         2
\\   0000 0000 0000                                                   3
\\   1101                                                             1     =8
\\   0000 0000 0000 0000 0000 0000                                    5
\\
\\   1101                                                             1
\\   0000                                                             1
\\   11111111 11111111 11111111 11111111 11111111 11111101            12
\\   0000                                                             1     =28
\\
\\   1101                                                             1     =29
\\   00000000
\\
check_exact(dragon_fpoint(3/4), 1/2);
check_exact(dragon_fpoint(FFFD(0) + FFFD(1)/16^2), from_binary(11010001)/256);
check_exact(dragon_fpoint(from_binary(0000 0000 11111101)/16^4), 17/256);
check_exact(              from_binary(00010001)/16^2  , 17/256);
check_exact(dragon_fpoint(from_binary(00010001        )/16^2), -5/16);

check_exact(to_binary(dragon_fpoint(FFFD(0) \
                     )*16), \
       1100);

check_exact(to_binary(dragon_fpoint(FFFD(0) \
                                  + FFFD(1)/16^2 \
                     )*16^2), \
       1101 0001);

check_exact(to_binary(dragon_fpoint(FFFD(0) \
                                  + FFFD(1)/16^2 \
                                  + FFFD(0)/16^7 \
                     )*16^4), \
       1101 0000 11111101);

check_exact(to_binary(dragon_fpoint(FFFD(0) \
                                  + FFFD(1)/16^2 \
                                  + FFFD(0)/16^7 \
                                  + FFFD(0)/16^14 \
                     )*16^8), \
       1101 0000 11111101 0000 0000 0000 1100);
check_exact(b^-32, 1/16^4);

check_exact(to_binary(dragon_fpoint(FFFD(0) \
                                  + FFFD(1)/16^2 \
                                  + FFFD(0)/16^7 \
                                  + FFFD(0)/16^14 \
                                  + FFFD(11)/16^16 \
                     )*16^14), \
       1101 0000 11111101 0000 0000 0000 1101 0000 0000 0000 0000 0000 0001);

quit


\\-----------------------------------------------------------------------------
\\ 0,D,F

n_to_0DF(n) = fromdigits(apply(d->if(d==0,0,d==1,13,15), digits(n,3)), 16);

# FFF D 000 repeat
ternary_is_ffd(n) =
{
  my(v=digits(n,3));
  if(v[#v]==2,return(1));
  for(i=1,#v-1,
     if(v[i]==1 && v[i+1]==1, return(1));  \\ DD
     if(v[i]==1 && v[i+1]==2, return(1));  \\ DF
     if(v[i]==2 && v[i+1]==0, return(1));  \\ F0
  );
  0;
}

{
  for(n=1,100,
     \\if(ternary_is_ffd(n),next());
     my(df=n_to_0DF(n),len=#digits(df,16));
     printf("%X %s\n", df, dragon_fpoint(df/16^len));
     );
  quit;
}


\\-----------------------------------------------------------------------------

\\ srev smallest 0.232323...
check_exact(fracper_to_frac([ [2,3]],4), 11/15);
check_exact(dragon_fpoint(4/15), -2/3*I);
check_exact(fromdigits([2,3, 2,3, 2,3, 2,3],4), 48059);
\\ 48059/4^8*15.0 = 10.9999

\\ erev biggest 0.010101...
check_exact(fracper_to_frac([ [0,1]],4), 1/15);
check_exact(dragon_fpoint(14/15), 1+1/3*I);

\\ k=4
\\ N range
\\ 11/16 + (11/15)/16 == 11/15
\\ 13/16 + (1/15)/16  == 49/60
\\
\\ X range
\\ 1/2-(2/3)/4 == 1/3
\\ 3/4+(1/3)/4 == 5/6

frac_to_fracper(1/3,2) == .01010101
frac_to_fracper(5/6,2) == .11010101

\\ k=8
v=vector(16,x,x--; dragon_unpoint(x,1));
v=concat(v,vector(16,x,x--; dragon_unpoint(x,-1)));
v=select(an->an[1]==0,v)
v=apply(an->an[2],v)
v=vecsort(v)
apply(dir,v)%4
apply(dragon_point,v)
binary(208)

\\ 188/256.0
\\ 6/16.0 + (7/6)/16.0    \\ X too small

\\ 193/256.0
\\ 7/16.0 + (7/6)/16.0    \\ X too small

\\ 204/256.0
\\ 10/16.0 + (7/6)/16.0   \\ X too small
\\ 205/256.0
\\ 11/16.0 + (7/6)/16.0   \\ X too small

\\ 208/256.0
\\ 12/16.0 - (7/6)/16.0   \\ X low in range
\\ 12/16.0 + (7/6)/16.0   \\ X high in range
turn(208)
dir(208)%4
dir(209)%4

\\                |
\\                v
\\      208----->209
\\       |
\\       v

\\-----------------------------------------------------------------------------

\\ n=1101                j=0
\\   0000
\\
\\   11111101            j=1
\\   000000000000
\\   1101                j=2
\\   000000000000000000000000
\\
\\   1101                j=3
\\   0000
\\   111111111111111111111111111111111111111111111101     j=4
\\   0000
\\
\\   1101
\\   00000000
\\   11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111101
\\   0000
\\
\\   11111101
\\   0000
\\   1101
\\   0000000000000000
\\
\\   111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111101
\\   0000
\\   11111101
\\   000000000000
\\
\\   1101
\\   00000000
\\   1101
\\   0000
\\   11111111111111111111111111111111

\\ n=11010000111111010000000000001101000000000000000000000000
\\    ---     -------             ---
check_exact(3/4,     b^-1 - b^-2 - b^-4);   \\ 1101
check_exact(17/16,   b^-1 - b^-2 - b^-3 - b^-4 - b^-5 - b^-6 - b^-8) \\ 1111 1101
check_exact(257/256, b^-1 - sum(i=2,14,b^-i) - b^-16) \\ 1111...1101 in 16 bits
dragon_fpoint(from_binary(1101)/2^4)


check_exact(to_binary((3/4+257/256/256) * 256^2), 1100000100000001);
\\                                                ****\--/


quit

{
  k=2^10;
  fs=[0];
  my(verbose=0);
  my(flen=1, zlen=1);
  for(reps=1,k,
     print("reps="reps);
     if(verbose,print("at flen="flen" zlen="zlen," #fs=",#fs));
     if(verbose && #fs<30, print("  ",fs));

     if(verbose && reps<10,
        print1("  ");
        for(i=1,#fs,
           print1(fs[i]/flen);
           while(i<#fs && fs[i+1]==flen+fs[i], i++);
           print1("--"fs[i]/flen",  "));
        print());

     if(verbose,
        my(runs=0);
        for(i=1,#fs,
           runs++;
           while(i<#fs && fs[i+1]==flen+fs[i], i++));
        print("  runs ",runs,"  mean ",#fs/runs*1.0);
       );

     my(new_fs=List([]), skip=0);
     flen/=2;
     zlen/=sqrt2;
     my(zlimit=2*zlen);
     for(i=1,#fs,
        my(f=fs[i]);
        for(step=0,1,
           my(z=dragon_fpoint(f));
           if(abs(imag(z)  ) > zlimit, skip++; next());
           if(abs(real(z)-f) > zlimit, skip++; next());
           listput(new_fs,f);
           f+=flen);
     );
     fs=new_fs;
     if(verbose, print("  skip ",skip));
  );
}
{
  for(i=1,#fs,
     my(z=dragon_fpoint(fs[i]));
     print(fs[i]*1.0);
     print(" n="to_binary(fs[i]*2^k));
     print(" x="to_binary(real(z)*2^(k/2)));
  );
}

\\ #"111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111"
\\ #"1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111"


\\ 0.8163604766596108788302178783
\\ cf Kempner-Mahler
\\ 0.816421509021893143708079
\\ 0.0000610    differs at bit 2^-15, and sum those bits for 2^-14
\\ printf("%f",2.0^-14)
\\ 36+6==42