\\ Copyright 2014, 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

P8dash(k) = b^(k+1) - I*P8(k);
P10_to_P8dash(k) = (P8dash(k-1) - P10(k-1))/b^k * sqrt2^k;
vector(10,k,k+=6; P10_to_P8dash(k))

\\-----------------------------------------------------------------------------

P1gaps(k)  = if(k==6,1, P7gaps(k-1) + P10gaps(k-1) + 1);
P2gaps(k)  = if(k==6,1, P1gaps(k-1));
P3gaps(k)  = if(k==6,0, P2gaps(k-1));
P4gaps(k)  = if(k==6,0, P3gaps(k-1));
P5gaps(k)  = if(k==6,1, 1);
P6gaps(k)  = if(k==6,0, P2gaps(k-1));
P7gaps(k)  = if(k==6,0, P3gaps(k-1));
P8gaps(k)  = if(k==6,0, P4gaps(k-1));
P9gaps(k)  = if(k==6,1, P5gaps(k-1));
P10gaps(k) = if(k==6,0, P6gaps(k-1));

P1gaps = memoize( P1gaps );
P2gaps = memoize( P2gaps );
P3gaps = memoize( P3gaps );
P4gaps = memoize( P4gaps );
P5gaps = memoize( P5gaps );
P6gaps = memoize( P6gaps );
P7gaps = memoize( P7gaps );
P8gaps = memoize( P8gaps );
P9gaps = memoize( P9gaps );
P10gaps = memoize(P10gaps);

HVgaps(k) =
{
  P1gaps(k) +
  P2gaps(k) +
  P3gaps(k) +
  P4gaps(k) +
  P5gaps(k) +
  P6gaps(k) +
  P7gaps(k) +
  P8gaps(k) +
  P9gaps(k) +
  P10gaps(k);
}

{
  for(k=6,20,
     print(k"  ",HVgaps(k),"  ",
           [P1gaps(k),
            P2gaps(k),
            P3gaps(k),
            P4gaps(k),
            P5gaps(k),
            P6gaps(k),
            P7gaps(k),
            P8gaps(k),
            P9gaps(k),
            P10gaps(k)])
  );
}

\\ vector(120,k,k+=5; HVgaps(k))

HVgaps_formula(k) =
{
   1/4 * vector_modulo([15, 18, 20, 24],k) * 2^floor(k/4)
   - 6;
}
check_exact(vector(100,k,k+=5; HVgaps_formula(k)), \
            vector(100,k,k+=5; HVgaps(k)))

\\-----------------------------------------------------------------------------

P1v(k)  = if(k==6,3, P7v(k-1) + 1 + P10v(k-1));
P2v(k)  = if(k==6,1, P1v(k-1));
P3v(k)  = if(k==6,3, P2v(k-1));
P4v(k)  = if(k==6,1, P3v(k-1));
P5v(k)  = if(k==6,1, 1);
P6v(k)  = if(k==6,3, P2v(k-1));
P7v(k)  = if(k==6,1, P3v(k-1));
P8v(k)  = if(k==6,1, P4v(k-1));
P9v(k)  = if(k==6,1, P5v(k-1));
P10v(k) = if(k==6,1, P6v(k-1));

P1v = memoize( P1v );
P2v = memoize( P2v );
P3v = memoize( P3v );
P4v = memoize( P4v );
P5v = memoize( P5v );
P6v = memoize( P6v );
P7v = memoize( P7v );
P8v = memoize( P8v );
P9v = memoize( P9v );
P10v = memoize(P10v);

HV(k) =
{
  P1v(k) +
  P2v(k) +
  P3v(k) +
  P4v(k) +
  P5v(k) +
  P6v(k) +
  P7v(k) +
  P8v(k) +
  P9v(k) +
  P10v(k);
}

{
  for(k=6,20,
     print(k"  ",HV(k),"  ",
           [P1v(k),
            P2v(k),
            P3v(k),
            P4v(k),
            P5v(k),
            P6v(k),
            P7v(k),
            P8v(k),
            P9v(k),
            P10v(k)])
  );
}

\\ vector(120,k,k+=5; HV(k))

HV_formula(k) =
{
  1/2 * vector_modulo([15, 17, 22, 26],k) * 2^floor(k/4)
  - 6;
}
check_exact(vector(100,k,k+=5; HV_formula(k)), \
            vector(100,k,k+=5; HV(k)))
