\\ Copyright 2014 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

read("../tools/memoize.gp");

\\ M = [ 0,1,0; 0,0,1; a,b,c ]
\\ M*[f(0..len-1)] = f(len)
\\ M*[f(1..len)] = f(len+1)
\\ [ a,b,c; a,b,c; a,b,c ] * [ 

recurrence_guess_func(func) =
{
  for(len=1,20,
     print("len=",len);
     my(m = matrix(len,len, r,c, func(r+c-2)),
        v = vectorv(len,i, func(len+i-1)));
     \\ print("m=",m);
     \\ print("v=",v);
     print("det ",);
     iferr(coeffs = matsolve(m,v),
           e,
           print("no inverse");
           next,
           errname(e)=="e_INV");
     \\ print("coeffs ",coeffs);
        
     vand = matrix(len,len, r,c, c==r+1);
     vand[len,]=coeffs~;
     \\ print("vand ",vand);
     
     v = vectorv(len,i, func(i-1));
     my(good=1);
     for(i=len,len+20,
        v = vand*v;
        my(want = func(i),
           got  = v[len]);
        if(got != want,
           print("different at i=",i," got ",got," want ",want);
           good=0;
           break));
     if(good, return(vand[len,])));
}
recurrence_guess(func) =
{
  my(v = recurrence_guess_func(func),
     p = Pol(concat(-v,[1])));
  print("terms ",v);
  my(f=factor(p));
  \\ print("factors ",f);
  for(i=1,matsize(f)[1],
     my(term=f[i,1]);
     \\ print(poldegree(term));
     if(poldegree(term)==1,
        print("factor ",term,"   abs ",abs(polcoeff(term,0))),

        print("factor ",term);
        my(roots=polroots(term));
        for(j=1,#roots,
           print("  root ",roots[j],"   abs ",abs(roots[j])))));
}

recurrence_guess(i->F(i+4))

\\-----------------------

b = 1+I;
L(k) = if(k<0,error("L k<0"), k<=3,2^k, L(k-1) + 2*L(k-3));
L=memoize(L);
R(k)=1 + sum(j=0,k-1, L(j));
R = memoize(R);

recurrence_guess(R)

left_boundary_centroid_initial = [1/2, 3/2 + 1/2*I, 2 + 3*I, -3 + 9*I];
left_boundary_centroid =
{
  memoize(k->
          if(k<0, error("not k<0"));
          if(k<4, return(left_boundary_centroid_initial[k+1]));
          my(bk = b^(k-4));
          left_boundary_centroid(k-1)
          - 2*left_boundary_centroid(k-3)
          + L(k-3)*bk*(-3+I)
          + R(k-3)*bk*(-2-2*I));
}

recurrence_guess(left_boundary_centroid)

\\ recurrence_guess(k->left_boundary_centroid(k)*L(k))
