\\ Copyright 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want, name="") =
{
  check_count++;
  if(got!= want,
     print("\nwrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count"  "name));
}


\\-----------------------------------------------------------------------------

StoN_by_count(n,d) = sum(i=0,n-1, dir(i)%4==d);

  # N= 2^k0 + 2^k1 + 2^k2
  # my(d=1); [Skd(2,d), Skd(1,d-1), Skd(0,d-2)]
  # my(d=1); Skd(2,d) + Skd(1,d-1) + Skd(0,d-2)

\\ StoN_by_bits(n,d) =
\\ {
\\   my(v=binary(n),total=0); 
\\   for(i=1,#v,
\\      if(v[i],
\\         total+=s*Skd(#v-i,d); 
\\         d++));
\\   total;
\\ }
\\ {
\\   for(n=0,10,
\\      print("n="n
\\            "  "apply(d->StoN_by_bits(n,d),[0,1,2,3])
\\            "  "apply(d->StoN_by_count(n,d),[0,1,2,3])));
\\ }
\\ check_exact(matrix(100,4,n,d,d--; StoN_by_bits(n,d)), \
\\             matrix(100,4,n,d,d--; StoN_by_count(n,d)), \
\\            "StoN_by_bits");


StoN_by_powers(n,d) =
{
  1/4 * (n
         + 2*real(dragon_point(n)*(-I)^d)
         + (n%2)*(-1)^d);
}
{
  forstep(n=1,20,1,
     my(by_powers=apply(d->StoN_by_powers(n,d),[0,1,2,3]));
     my(by_count=apply(d->StoN_by_count(n,d),[0,1,2,3]));
     print("n="n"  "by_powers"  "by_count"  "by_powers-by_count));
}
check_exact(matrix(100,4,n,d,d--; StoN_by_powers(n,d)), \
            matrix(100,4,n,d,d--; StoN_by_count(n,d)), \
           "StoN_by_powers 2");
quit
