#!/usr/bin/perl -w

# Copyright 2019, 2020 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyDragon
  '@BitAboveLowestOne_HtoL_state_table',
  '@BitAboveLowestOne_HtoL_state_to_result',
  '@BitAboveLowestOne_LtoH_state_table',
  '@BitAboveLowestOne_LtoH_state_to_result',
  '@BitAboveLowestOne_LtoH_state_name';
use MyPrintwrap ':all';
use MyFLAT;
$|=1;

print "% generated by tools/$FindBin::Script\n";

printwrap_indent("% GP-DEFINE  ");
printwrap_gp_matrix(\@BitAboveLowestOne_HtoL_state_table,
                    "BitAboveLowestOne_HtoL_state_table");
printwrap_gp_vector(\@BitAboveLowestOne_HtoL_state_to_result,
                    "BitAboveLowestOne_HtoL_state_to_result");

printwrap_gp_matrix(\@BitAboveLowestOne_LtoH_state_table,
                    "BitAboveLowestOne_LtoH_state_table");
printwrap_gp_vector(\@BitAboveLowestOne_LtoH_state_to_result,
                    "BitAboveLowestOne_LtoH_state_to_result");
foreach my $state (0 .. $#BitAboveLowestOne_LtoH_state_table) {
  my $name = $BitAboveLowestOne_LtoH_state_name[$state];
  print "% GP-DEFINE  BitAboveLowestOne_LtoH_$name = $state;\n";
}

print "% end generated\n";
exit 0;
