#!/usr/bin/perl -w

# Copyright 2020 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyDragon ':all';
use MyPrintwrap ':all';


print "    % generated by tools/$FindBin::Script\n";

my $limit = 15;
my @values;
foreach my $n (1 .. 15) {
  my $prev = $n-1;
  my $at = ($n==1 ? "at (0,0)" : "[base right=0 of field$prev]");
  my $value = BitAboveLowestOne($n);
  print "    \\node (field$n) $at {\$$value\$};\n";
  push @values, $value;
}
print "% GP-Test  vector($limit,n,BitAboveLowestOne(n)) ==[",
  join(',',@values),"]\n";

print "    % end generated\n";
exit 0;
