#!/usr/bin/perl -w

# Copyright 2016, 2017, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use Math::PlanePath::DragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
use lib $FindBin::Bin;
use MyDragon 'BlobN';
use MyLineSegments;
use MyPrintwrap ':all';


print "  % generated by tools/$FindBin::Script\n";
my $path = Math::PlanePath::DragonCurve->new;

foreach my $level (7 .. 8) {
  $Printwrap = 2;
  print "  \\begin{scope}[shift=(pos-$level)]\n";
  my $n_lo = BlobN($level) - 3;
  my $n_hi = BlobN($level+1);

  $Printwrap = 4;
  my $segments = MyLineSegments->new;
  foreach my $n ($n_lo .. $n_hi-1) {
    my ($x,$y) = $path->n_to_xy($n);
    my ($x2,$y2) = $path->n_to_xy($n+1);
    $segments->add($x,$y, $x2,$y2);
  }

  printwrap("\\draw[my dragon] ");
  $Printwrap += 2;
  $segments->printwrap;
  printwrap(";\n");

  $Printwrap = 4;
  {
    my ($x,$y) = $path->n_to_xy($n_lo+3);
    printwrap("\\node (start-$level) at ($x,$y) [my dot];\n");
    print "% GP-Test  BlobStart($level) == $x + I*$y\n";
  }
  {
    my ($x,$y) = $path->n_to_xy($n_hi-3);
    printwrap("\\node (end-$level) at ($x,$y) [my dot];\n");
    print "% GP-Test  BlobEnd($level) == $x + I*$y\n";
  }

  print "  \\end{scope}\n";
}

print "  % end generated\n";
exit 0;
