#!/usr/bin/perl -w

# Copyright 2014, 2015, 2016, 2017, 2018 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.010;
use strict;
use warnings;

use FindBin;
use lib $FindBin::Bin;
use MyDragon ':all';
use MyPrintwrap ':all';


$Printwrap = 2;
printwrap("% generated by tools/$FindBin::Script\n");

my $level = 11;

sub draw {
  my ($style, $dash, $points) = @_;
  $style //= '';
  if ($style ne '') { $style = ",$style"; }
  $style = "[thin$style]";
  $dash ||= '';
  $Printwrap = 2;
  printwrap("\\draw$style ");
  my $join = '';
  $Printwrap = 4;
  my $i = 1;
  foreach my $p (@$points) {
    my ($x,$y) = @$p;
    printwrap("$join($x,$y) node[my dot,name=P$i$dash]\n");
    $join = '--';
    $i++;
  }
  printwrap("--cycle;\n");
}

my $ex = 1;
my $ey = 0;

foreach (1 .. int(($level+1)/2)) {
  ($ex,$ey) = ($ey,-$ex);  # rotate -90
}

my $points = [
              [0,0],
              [$ex,$ey],
             ];

foreach (1 .. $level) {
  ($points,$ex,$ey) = hull_expand($points,$ex,$ey);
  #  print "  % count ",scalar(@$points),"\n";
}

$Printwrap = 2;
printwrap("\\node (M) at ($ex,$ey) [my dot];\n");
draw('', 'a', $points);
draw('', 'b', [ map {[unfold(@$_,$ex,$ey)]} @$points ]);

($points,$ex,$ey) = hull_expand($points,$ex,$ey);
# draw('dashed', 'e', $points);

$Printwrap = 2;
printwrap("\\node (end) at ($ex,$ey) [my dot];\n");
print "  % end generated\n";
exit 0;
