#!/usr/bin/perl -w

# Copyright 2014, 2016, 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use Math::PlanePath::R5DragonCurve;

use FindBin;
BEGIN { unshift @INC, $FindBin::Bin }
use MyTerdragon ':all';
use MyPrintwrap ':all';


my $width = 20;
my $height = 9;
printwrap("  % generated by tools/$FindBin::Script\n");

sub in_range {
  my ($x,$y) = @_;
  return ($x >= 0 && $x <= $width
          && $y >= 1 && $y <= $height);
}

sub draw {
  my ($x1,$y1, $x2,$y2) = @_;
  my $x = ($x2 + $x1)/2;
  my $y = ($y2 + $y1)/2;
  my $dy = ($y2 - $y1)/2;
  if (in_range($x1,$y1)) {
    if ($dy) {
      $x1 += 1;
      $y1 += $dy;
    } else {
      $x1 += 2;
    }
  }
  if (in_range($x2,$y2)) {
    if ($dy) {
      $x2 -= 1;
      $y2 -= $dy;
    } else {
      $x2 -= 2;
    }
  }
  if ($x1 != $x2) {
    printwrap " ($x1,{$y1*sqrt(3)})--($x2,{$y2*sqrt(3)})";
  }
}

printwrap("  \\draw\n");
printwrap_indent("   ");
foreach my $y ($y_min .. $y_max) {
  if ($y % 2 == 0) {
    printwrap("($x_min,$y)--($x_max,$y)");
  }
}
foreach my $x ($x_min .. $x_max) {
  if ($x % 2 == 0) {
    printwrap("($x,$y_min)--($x,$y_max)");
  }
}
printwrap(";\n");

printwrap_indent(" ");
foreach my $y ($y_min .. $y_max) {
  foreach my $x ($x_min .. $x_max) {
    if ($x % 2 == 0 && $y % 2 == 0) {
      printwrap(" \\fill ($x,$y)circle;");
    }
  }
}
printwrap_newline();

printwrap_indent("  ");
printwrap("% end generated\n");
exit 0;
